var BASE_GRAPH_ID = 'relationship'
var chart = echarts.init(document.getElementById('echarts'));

var nodes = [
    { name: '节点1', value: [100, 200] },
    { name: '节点2', value: [300, 200] },
    { name: '节点3', value: [200, 100] },
    { name: '节点4', value: [200, 300] },
]

var links = [
    [ [0, 1], '关系1', 0.2 ],
    [ [1, 0], '关系2', 0.2 ],
    [ [0, 2] ], [ [1, 2] ], [ [1, 3] ], [ [0, 3] ],
];

links = echarts.util.map(links, function(l) {
    return {
        source: l[0][0],
        target: l[0][1],
        label: l[1]?{
            show: true,
            formatter: l[1],
        }:{},
        lineStyle: l[2]?{ curveness: l[2] }:{}
    }
})

var dataOption = {
    title: { text: '可拖拽关系图' },
    animation: false,
    series : [{
        id: BASE_GRAPH_ID,
        type: 'graph',
        coordinateSystem: 'cartesian2d',
        symbolSize: 50,
        label: { show: true },
        edgeSymbol: ['none', 'arrow'],
        edgeSymbolSize: [0, 10],
        data: nodes,
        links: links,
        lineStyle: { width: 2 }
    }],
    xAxis: {
        min: 0,
        max: 400,
        type: 'value',
        show: false,
    },
    yAxis: {
        min: 0,
        max: 400,
        type: 'value',
        show: false,
    },
};

chart.setOption(dataOption);

var dragOption = {
    graphic: echarts.util.map(nodes, function (item, i) {
        return {
            type: 'circle',
            shape: { r: 25 },
            position: chart.convertToPixel({seriesId: BASE_GRAPH_ID}, item.value),
            invisible: true,
            draggable: true,
            z: 100,
            ondrag: echarts.util.curry(onPointDragging, i),
        }
    }),
};

function onPointDragging(index) {
    newPosition = chart.convertFromPixel({seriesId: BASE_GRAPH_ID}, this.position);
    nodes[index].value = newPosition;
    chart.setOption({
        series: [{
            id: BASE_GRAPH_ID,
            data: nodes
        }]
    });
}

chart.setOption(dragOption);
